import net.yajjl.*
import com.bleedingwolf.ratpack.*

public class AutoCompleteApp {
	def root
	def serializer = new JsonSerializer()
	def app = Ratpack.app {
		set 'public', 'public'
		set 'templateRoot', 'templates'

		get("/") {
				"hello world"
		}
		
		post("/autoCompleteLocation") {
			println params
			def x = root.autocomplete(params.query)
			def list = []
			for (i in x) {
				list.add([
					value:i.extraData["displayName"], 
					text:i.extraData["displayName"]+", "+i.extraData["location"]
				])
			}

			serializer.serialize(list)			
		}
	}

	public AutoCompleteApp() {
		setupTries()
		println root.count
		RatpackServlet.serve(app)
	}

	public setupTries() {
		root = new Trie(null,null)

		def parser = new JsonParser()
		def text = new File('worldairports.json').getText()
		def airports = parser.parseArray(text)
		airports.each {
			if (it.type.equals('Railway Stations'))
				if (it.name.equals(""))
					it.name =  it.city+", "+it.state+" Rail"
			def name =  it.name
			def location =  it.city+", "+it.state+", "+it.country
			def code = it.code
			root.insert(name.toLowerCase(), [displayName:name, location:location, code:code])
		}
		//codes
		airports.each {
			if (it.type.equals('Airports')) {
				def location =  it.city+","+it.state+","+it.country
				root.insert(it.code.toLowerCase(), [displayName:it.name,code:it.code, location:location])
			}
		}
	}

	public static void main(String[] args) {
		new AutoCompleteApp()
	}

} 
