import net.yajjl.*

public class Trie {
    HashMap children = [:]
    def value
    def extraData = [:]
		def count = 0
    def flag = false    // Flag to indicate that a word ends at this node
    public Trie(value, flag=false) {
        this.value = value
        this.flag = false
    }

    def add = { character ->
        def val = (this.value != null) ? this.value + character : character
        this.children[character] = new Trie(val)
    }

    def insert = { word, data ->
        def node = this
        for (character in word) {
            if (node.children[character] == null) {
                node.add(character)
            }
            node = node.children[character]
        }
        node.flag = true
        node.extraData = data
				count++
    }

    def find = { word ->
        def node = this
        for (character in word) {
            if (node.children[character] == null)
                return null
            node = node.children[character]
        }
        
        return node.value
    }
    
    
    def all_prefixes = { ->
        HashSet results = new HashSet()
        if(this.flag) {
            results.add(this)
        }
        if(this.children.size() == 0) {
            return results
        }
        //return {
            for (node in this.children.values()){
                results.add(node.all_prefixes())
            }
            results
        //}()
    }
    
    def autocomplete = {prefix ->
        prefix = prefix.toLowerCase()
				def node = this
        for(character in prefix) {
            if(node.children[character] == null) {
                return
            }
            node = node.children[character]
        }
        return node.all_prefixes().flatten()
    }
   }


